//******************************************
//  : MQ6812_UART
// 汾     : V 1.00
//      : UARTʹú
// ע     :
//******************************************

#include "main.h"


uchar flowFlag, rcv_cnt;
uchar uart1_status, tx1_data, rx1_data;

//*********************************************************************
//    : UART1_Init
//  : IO,UARTʼ
// ע     : ģʽΪNormal1,Normal2
//*********************************************************************
void UART1_Init(void)
{
//====== ܽųʼ ======
    P9CR_P1 = 0;                        // 趨P91
    P9CR_P0 = 1;                        // 趨P90
    P9FC_P0 = 1;                        // лP90Ϊ⹦ܽ

    UATCNG_UAT2IO = 0;                  // 0: 趨 P90 P91 Ϊڹܽţ     1: 趨 P26 P27 Ϊڹܽ
    UATCNG_UAT1IO = 0;                  // 0: 趨 P90( P26) TX, P91( P27) RX 1: 趨 P91( P27) TX, P90( P26) RX

//====== ܿ( Enable) ======
    POFFCR1_UART1EN = 1;                // ȿݴò

//====== 趨 ======
	UART1CR1_PE		= 0;				// żУλ
	UART1CR1_STOPBT	= 0;				// TXֹͣλ : 1λ
	UART1CR2_STOPBR	= 0;				// RXֹͣλ : 1λ
	UART1CR1_BRG	= 0;				// 0: շʱ = fcgck
										// 1: շʱ = TCA0  (ɴɼBaud rate)

//------ Baud rate = 9600
//--- fcgck @ 16MHz
/* 
    UART1CR2_RTSEL = 0x01;
    UART1DR        = 0x64;
 */	
//--- fcgck @ 8MHz
/* 
    UART1CR2_RTSEL = 0x04;
    UART1DR        = 0x30;
 */
//--- fcgck @ 4MHz

    UART1CR2_RTSEL = 0x00;
    UART1DR        = 0x19;
	
//--- fcgck @ 2MHz
/* 
    UART1CR2_RTSEL = 0x00;
    UART1DR        = 0x0c;
 */

//------ Baud rate = 115200
//--- fcgck @ 16MHz
/* 
    UART1CR2_RTSEL = 0x03;
    UART1DR        = 0x08;
 */
//--- fcgck @ 8MHz
/* 
    UART1CR2_RTSEL = 0x04;
    UART1DR        = 0x03;
 */
//--- fcgck @ 4MHz
/* 
    UART1CR2_RTSEL = 0x04;
    UART1DR        = 0x01;
 */
//--- fcgck @ 2MHz
/* 
    UART1CR2_RTSEL = 0x04;
    UART1DR        = 0x00;
 */

}


//*********************************************************************
//    : UART1_Start
//  : UART
// ע     :
//*********************************************************************
void UART1_Start(void)
{
    UART1CR1_TXE = 1;                   //  TX
    UART1CR1_RXE = 1;                   //  RX
}


//*********************************************************************
//    : UART1_Stop
//  : ֹͣUART
// ע     :
//*********************************************************************
void UART1_Stop(void)
{
    UART1CR1_TXE = 0;                   // ֹͣ TX
    UART1CR1_RXE = 0;                   // ֹͣ RX
}


//*********************************************************************
//    : UART1_IntEnable
//  : UARTж
// ע     : ִкῪж(IMF)
//*********************************************************************
void UART1_IntEnable(void)
{
    DI;                                 // ֹпж 
/* 	
    IL_INTTXD1      = 0;                // TXж
    EI_INTTXD1      = 1;                // 趨TXж
 */	
    IL_INTRXD1      = 0;                // RXж
    EI_INTRXD1      = 1;                // 趨RXж
    EI;                                 // пж 
}


//*********************************************************************
//    : UART1_IntDisable
//  : ֹUARTж
// ע     : ִкῪж(IMF)
//*********************************************************************
void UART1_IntDisable(void)
{
    DI;                                 // ֹпж 
/* 	
    EI_INTTXD1      = 0;                // TXж
	IL_INTTXD1      = 0;                // TXж    
 */	
    EI_INTRXD1      = 0;                // RXж
	IL_INTRXD1      = 0;                // RXж    
    EI;                                 // пж 
}



//*********************************************************************
//    : IntRXD1
//  : жӳ
// ע     :
//*********************************************************************
void __interrupt IntRXD1(void)
{
	uart1_status = UART1SR;             // get flag data [PERR, FERR, OERR, -, RBSY, RBFL, TBSY, TBFL]
                                        // PERR    żУ      0: żУ
                                        //                            1: żУ
                                        // RFERR   շ        0: շ
                                        //                            1: շ
                                        // OERR              0: 
                                        //                            1: 
                                        // RBSY    æµ          0: ǰչ
                                        //                            1: 
                                        // RBFL    ջ     0: ջΪ
                                        //                            1: ջ
                                        // TBSY    æµ          0: ǰ͹
                                        //                            1: 
                                        // TBFL    ͻ     0: ͻΪ
                                        //                            1: ͻ

	rx1_data = RD1BUF;                  // ȡ RX ݺ

    if( flowFlag == PKG_WAIT_RCV ){		// ǰ״̬Ϊ 0x00(PKG_WAIT_RCV)RXΪ 0x55(PKG_RCV)
    	if( (rx1_data == PKG_RCV) ){	// ״̬Ϊ 0x55(PKG_RCV)
			rcv_cnt = 0;
    		flowFlag = PKG_RCV;         
    	}
    }
    else if( flowFlag == PKG_RCV ){		// ǰ״̬Ϊ PKG_RCV RXݴrx1_buf[]
        rx1_buf[rcv_cnt] = rx1_data;
    	rcv_cnt++;

    	if( rcv_cnt >= RCV_MAX ){
    	    rcv_cnt  = 0;
    		flowFlag = PKG_SEND;        // ָ״̬Ϊ PKG_SEND
    	}
    }
}





//*********************************************************************
//    : UART1_SendData
//  : UART1 ䷶
// ע     :
//*********************************************************************
void UART1_SendData(const uchar * buf,uint length)
{
    uint sendloop;

    for( sendloop = 0; sendloop < length; sendloop++ ){
        while( UART1SR_TBFL ){          // ȴͻΪգٴдҪʹ֮        
            CLR_WDT;                    // Źʱ (ι)
        }
        TD1BUF = buf[sendloop];
    }

    while( UART1SR_TBSY ){               // ȴ͹    
        CLR_WDT;                        // Źʱ (ι)
    }
}























